function Util () {}

/* Tag building */

Util.buildOpeningTag = function(tagName) {
    return '<' + tagName + '>';
};

Util.buildClosingTag = function(tagName) {
    return '</' + tagName + '>';
};

Util.wrapHTMLInTag = function(html, tagName) {
    return Util.buildOpeningTag(tagName) + html + Util.buildClosingTag(tagName);
};

/* Selection */

Util.rangeIsAtStartOfParent = function(range) {
    return (range.startContainer.previousSibling == null && range.startOffset == 0);
};

Util.rangeIsAtEndOfParent = function(range) {
    return ((range.startContainer.nextSibling == null || range.startContainer.nextSibling == "<br>")
        && range.endOffset == range.endContainer.length);
};

Util.removeHTMLTag = function(str) {
            str = str.replace(/<\/?[^>]*>/g,''); //去除HTML tag
            str = str.replace(/[ | ]*\n/g,'\n'); //去除行尾空白
            //str = str.replace(/\n[\s| | ]*\r/g,'\n'); //去除多余空行
            str=str.replace(/&nbsp;/ig,'');//去掉&nbsp;
            str=str.replace(/\s/g,''); //将空格去掉
            return str;
}