﻿
function pasteFormat(node){
	setTimeout(function() {
		var box = document.createElement('div');
		box.innerHTML = node.html();
		for(var i = 0, br = box.getElementsByTagName('br'); i < br.length; i++) {
			var delbr = null;
			if(!br[i].previousSibling) {
				delbr = br[i];
			} else if(!br[i].nextSibling) {
				delbr = br[i];
			};
			if(delbr && delbr.parentNode && delbr.parentNode.nodeName.toLowerCase() == 'p') {
				delbr.parentNode.removeChild(delbr);
				i--;
			}
		};
		beforeSubmit(box,true);
		clearEmptyP(box);
		node.html(box.innerHTML);
	}, 200);
	
}
function clearEmptyP(box) {
	//清除不合法的IFRAME
	var main = box || document;
	var iframes = main.getElementsByTagName('iframe');
	for(var i = 0; i < iframes.length; i++) {
		var src = iframes[i].getAttribute('src');
		if(!src) {
			if(iframes[i].getAttribute('data-src')) { //微信文章有的IFRAME没有SRC只有data-src
				src = iframes[i].getAttribute('data-src').replace(/(width|height)[^&]+/g, '');
				iframes[i].setAttribute('src', src);
				iframes[i].setAttribute('width', 665);
				iframes[i].setAttribute('height', 380);
			}
		};
		if(src) {
			src = src.toLowerCase();
			if(src.indexOf('v.qq.com') < 0 && src.indexOf('v.youku.com') < 0 && src.indexOf('player.youku.com') < 0 && src.indexOf('/musiceditor/musicplayer.html') < 0&& src.indexOf('/Edit/bookindex.html?') < 0) {
				src = null
			}
		};
		if(!src) {
			iframes[i].parentNode.removeChild(iframes[i])
		}
	}

	//清除div一些影像布局的样式
	var divs = main.getElementsByTagName('div');
	for(var i = 0; i < divs.length; i++) {
		if($(divs[i]).hasClass('blockquote_entirety_app')) {
			//			if($(divs[i]).prev().length==0&&!$(divs[i]).parent().hasClass('blockquote_entirety_app')){
			//				$('<p>.</p>').insertAfter($(divs[i]))
			//			}
			continue
		}
		if($(divs[i]).hasClass('color_in_app')) {
			continue
		}
		var csstext = divs[i].style.cssText + ';';
		if(csstext != ';') {
			csstext = csstext.toLowerCase().replace(/(min|max|padding|font)[^;]+/g, '').replace(/(; )+/g, ';').replace(/^;+/, "");
			divs[i].style.cssText = csstext;
		};
		if(divs[i].innerHTML == '') {
			divs[i].parentNode.removeChild(divs[i])
		}
	};

	function getInnerText(element) {
		return(typeof element.textContent == "string") ? element.textContent : element.innerText;
	}

	function notRemove(nobj) {
		var noRemove = true;
		var notremove = ["img", "embed", "object", "input", "iframe", "video", "audio", "hr", "a"];
		for(var i = 0; i < notremove.length; i++) {
			if(nobj.getElementsByTagName(notremove[i]).length > 0 || parseFloat(nobj.style.marginTop) < 0) {
				//http://www.360doc.com/content/17/1120/00/1197594_705557977.shtml   加marginTop<0是因为这篇文章
				//embed莫名不能显示，未找到根本原因。后期有时间看
				noRemove = false
			}
		}
		return noRemove;
	}
	var p = main.getElementsByTagName('p');
	if(p.length > 1) {
		for(var i = 0; i < p.length; i++) {
			if(notRemove(p[i]) && getInnerText(p[i]).replace(/\s+/g, "").replace(/&nbsp;/g, '').replace(/ /g, '').replace(/&#8203;/g, '') == '') {
				p[i].parentNode.removeChild(p[i]);
				i--
			} else {
				var csstext = p[i].style.cssText + ';';
				if(csstext != ';') {
					csstext = csstext.toLowerCase().replace(/(font|line-height)[^;]+/g, '').replace(/(; )+/g, ';').replace(/^;+/, "");
					p[i].style.cssText = csstext;
				};
			}
		}
	}
	var blockquote = main.getElementsByTagName('blockquote');
	for(var j = 0; j < blockquote.length; j++) {
		if(notRemove(blockquote[j]) && getInnerText(blockquote[j]).replace(/\s+/g, "").replace(/&nbsp;/g, '').replace(/ /g, '').replace(/&#8203;/g, '') == '') {
			blockquote[j].parentNode.removeChild(blockquote[j]);
			j--;
		}
	}
};

function beforeSubmit(box,filterClass) {//filterClass:黏贴传true;
	removeNodeList = [];
	textLength = 0;
	needJudgeBegin = true;

	//去除首尾空行，added by cai 2018/7/24
	domsrc(box,filterClass);
	domend(box);
	for(var i = 0; i < removeNodeList.length; i++) {
		if(removeNodeList[i] && removeNodeList[i].parentNode) {
			removeNodeList[i].parentNode.removeChild(removeNodeList[i]);
		}
	}
}


function domsrc(obj,filterClass) {//filterClass:黏贴传true;
	var curNode;
	var childNode;
	var imgSrc, imgDataSrc;
	var filterlist = new Array("className", "for", "method", "tabindex", "class", 'id');
	var classNameWhiteList = ['color_in_app', 'link_entirety_app', 'link_title_app', 'link_url_app', 'onImgAddText_', 'onImgAddText_img', 'onImgAddText_table', 'firstRow', 'list-paddingleft-2', 'edit360doctable', 'quote360doc','editor_bookframe','edit_coder'];

	var removeImgSrcList;

	try {
		curNode = obj;
		
		if(curNode.id!="zss_field_content"){
			if(curNode.nodeType == "8" || curNode.nodeType == "9") {
				removeNodeList.push(curNode);
			}

			if(curNode.nodeType == "3") {
				if(needJudgeBegin && curNode.nodeValue) {
					//alert("文本:" + curNode.nodeValue);
					text = Trim(curNode.nodeValue.replaceAll("&nbsp;", "").replace(/\u200B/g,''));
					textLength = textLength + text.length;
					//alert("长度：" + textLength);
					if(textLength > 0) {
						//alert(text);
						//alert("头部结束，不再删除，文字为" + text);
						needJudgeBegin = false;
					}
				}
			}

			if(curNode.nodeType == "1") {
				if(needJudgeBegin) {
					//如果自己是有意义的节点，不再删除
					if(isSingleLine(curNode)) {
						//alert("头部结束2，不再删除，html:" + curNode.innerHTML);
						needJudgeBegin = false;
					} else {
						//alert(curNode.innerHTML);
						//alert(getInnerText(curNode));
						text = Trim(getInnerText(curNode).replaceAll("&nbsp;", "").replace(/\u200B/g,''));
						//alert("标签下文字：" + text);
						//alert("text.length:" + text.length + " 总长度:" + textLength);
						//打头的文字
						if(text.length == 0 && textLength == 0) {
							//curNode下没有图片
							if(!hasSingleLine(curNode) && curNode && curNode.tagName && curNode.tagName.toLowerCase() != "body") {
								var tdHasBg = curNode.tagName == 'TD' && curNode.getAttribute('background') && curNode.getAttribute('backround') != '',
									trHasTdBg = curNode.tagName == 'TR' && curNode.innerHTML.toLowerCase().indexOf('background') > -1;
								if((!tdHasBg) && !trHasTdBg) {
									//有些空TD没内容 但是有背景图
									removeNodeList.push(curNode);
								}
								//空节点
								//alert("删除空节点:" + curNode.innerHTML);

							}
						}
					}
				}

				var attrs = curNode.attributes;


				//去除属性的on
				if(attrs != null) {
					for(var j = 0; j < attrs.length; j++) {
						var a = attrs[j].nodeName.toLowerCase();
						if(a.indexOf("on") == 0){
							curNode.removeAttribute(attrs[j].nodeName);
						}
					}
				};

				var cssStyle = curNode.getAttribute('style');
				if (cssStyle&&filterClass&&!$(curNode).attr("sureEdit")&&!$(curNode).parent().attr("sureEdit")) {
					cssStyle=cssStyle.replace(/!important/g,'');
					cssStyle = cssStyle.replace(/&quot;/g,'').replace(/(font-size|font-family|line-height|padding|margin-bottom|margin-top|outline)[^;]+/g, '').replace(/(; )+/g,';').replace(/^;+/,"");
					if(cssStyle.length==0){
						$(curNode).removeAttr("style");
					}else{
						curNode.setAttribute('style', cssStyle);
					}
				};
				if (curNode.nodeName.toLowerCase() == "p"&&filterClass) {  //去除空的p标签
					//alert("p标签");
					if (!hasSingleLine(curNode) && getInnerText(curNode).replaceAll("&nbsp;", "").replaceAll(" ", "").replace(/\u200B/g,'').length == 0) {
						//alert("delete");
						removeNodeList.push(curNode);
					}
				}
				if(curNode.nodeName.toLowerCase() == "script" || curNode.nodeName.toLowerCase() == "link" || curNode.nodeName.toLowerCase() == "meta" || curNode.nodeName.toLowerCase() == "select" || curNode.nodeName.toLowerCase() == "option" || curNode.nodeName.toLowerCase() == "textarea" || curNode.nodeName.toLowerCase() == "button" || curNode.nodeName.toLowerCase() == "applet" || !isVisibleNode(curNode)) {
					removeNodeList.push(curNode);
				} else if(curNode.nodeName.toLowerCase() == "img") {
					if(attrs != null) {
						imgSrc = "";
						imgDataSrc = "";
						removeImgSrcList = [];

						for(var j = 0; j < attrs.length; j++) {
							//if (curNode.nodeName.toLowerCase() == "img") {
							//alert(attrs[j].nodeValue);
							//}
							var a = attrs[j].nodeName.toLowerCase();
							var v = attrs[j].nodeValue;
							if(a == "href" || a == "src" || a == "data-src" || a == "real_src" || a == "data-ke-src" || a == "data-original" || a == "data-echo" || a == "img_src" || a == "original" || a == "data-actualsrc" || a == "data-timgurl" || a == "orgsrc" || a == "data-url" || a == "wqdata-src" || a == "gif_url" || a == "data-original-src" || a == "lazy-src" || a == "data-lazyload") {
								// delete javascript link
								if(v.toLowerCase().indexOf("javascript:") == 0 || v.indexOf("#") == 0 || v.indexOf("\\") == 0) {
									attrs[j].nodeValue = "";
									curNode.removeAttribute(attrs[j].nodeName);
								}
								// updated by cai 20151201
								else {
									//alert(v);
									if(v.length > 3) {
										attrs[j].nodeValue = v;
										//img节点的src
										if(curNode.nodeName.toLowerCase() == "img") {
											//imgSrc, imgDataSrc, imgDataOriginal, imgKeSrc, imgRealSrc;
											if(a == "src") {
												imgSrc = v;
											} else if(a == "data-src" || a == "real_src" || a == "data-ke-src" || a == "data-original" || a == "data-echo" || a == "img_src" || a == "original" || a == "data-actualsrc" || a == "data-timgurl" || a == "orgsrc" || a == "data-url" || a == "wqdata-src" || a == "gif_url" || a == "data-original-src" || a == "lazy-src" || a == "data-lazyload") {
												removeImgSrcList.push(a);
												imgDataSrc = v;
											}

										}
									} else //删除不正确的图片节点
									{
										if(a == "data-src" || a == "real_src" || a == "data-ke-src" || a == "data-original" || a == "data-echo" || a == "img_src" || a == "original" || a == "data-actualsrc" || a == "data-timgurl" || a == "orgsrc" || a == "data-url" || a == "wqdata-src" || a == "gif_url" || a == "data-original-src" || a == "lazy-src" || a == "data-lazyload") {
											//alert("data-src图片：" + v);
											removeImgSrcList.push(a);
										}
									}
								}
							}
						} //for
						//如果是img标签，没有src，也没有data-src，也没有real_src，也没有data-ke-src，则删除img标签
						if(curNode.nodeName.toLowerCase() == "img") {

							//处理src
							//如果有其他的src,则其他的src优先，替换掉src
							if(imgDataSrc.length > 0 && imgSrc.indexOf(":", 0) != 1) {
								//alert("替换src" + imgDataSrc);
								curNode.setAttribute("src", imgDataSrc);
								for(var i = 0; i < removeImgSrcList.length; i++) {
									//alert("开始删除" + removeImgSrcList[i]);
									curNode.removeAttribute(removeImgSrcList[i]);
								}

							} else {
								//没有其他的src
								if(imgSrc.length == 0) {
									//没有任何src,需要删除img节点
									removeNodeList.push(curNode);
								}
							}
						}
					} //if
				} else if(curNode.nodeName.toLowerCase() == "embed" || curNode.nodeName.toLowerCase() == "param") { //flash标签，安全性限制
					for(var j = 0; j < attrs.length; j++) {
						var a = attrs[j].nodeName.toLowerCase();
						if(a == "allowscriptaccess") {
							attrs[j].nodeValue = "never";
						}
					}
				}
				for(var i = 0; i < filterlist.length; i++) {
					if(filterlist[i] == 'class') {
						var curClass = curNode.className,
							WhiteList = false;
						for(var j = 0; j < classNameWhiteList.length; j++) {
							if(curClass.indexOf(classNameWhiteList[j]) > -1) {
								WhiteList = true;
								break
							}
						}
						if(!WhiteList) {
							curNode.nodeName.toLowerCase() != 'body' && curNode.removeAttribute('class');
						}
					} else {
						curNode.removeAttribute(filterlist[i]);
					}
				}
			}

		}
	} catch(err) {
		//alert(err + curNode.outerHTML);
	}

	for(var i = 0; i < obj.childNodes.length; i++) {

		childNode = obj.childNodes[i];

		if(childNode.nodeType == "1" || childNode.nodeType == "3" || childNode.nodeType == "8" || childNode.nodeType == "9") {

			domsrc(childNode,filterClass);
		}
	}

};


function isVisibleNode(node) {
	if(node.nodeType) {
		if(node.nodeType == 3) {
			return true;
		}

		if(navigator.appVersion.toString().toLowerCase().indexOf("msie", 0) != -1) {
			if(node.currentStyle != null && node.currentStyle['display'] == "none") {
				return false;
			}
		} else {
			try {
				if(window.getComputedStyle(node, null)['display'] == "none") {
					return false;
				}
			} catch(e) {
				return false;
			}
		}
		return true;
	} else {
		return false;
	}
}

function getInnerText(elm) {
	try {
		if(window._isIE) {
			return elm.innerText;

		} else {

			return elm.textContent;
		}
	} catch(err) {
		return "";
	}
}

function domend(obj) {
	var cruNode, parentNode, deleteNode;
	var text = "";
	//找到最后一个节点
	curNode = obj;
	try {
		while(curNode.hasChildNodes()) {
			curNode = curNode.lastChild;
		}

		if(curNode.nodeType == 3) {
			curNode = curNode.parentNode;
		}

		//alert("最后一个节点, 节点值：" + curNode.outerHTML);

		text = Trim(getInnerText(curNode).replaceAll("&nbsp;", ""));
		text = decodeURI(encodeURI(text).replace(/%E2%80%8B/g, "")); //&#8203;没被Trim掉 不能放过
		if(text.length == 0 && !hasSingleLine(curNode)) {
			deleteNode = curNode;
			parentNode = curNode.parentNode;
			while(parentNode && text.length == 0) {
				curNode = parentNode;
				parentNode = curNode.parentNode;
				text = Trim(getInnerText(curNode).replaceAll("&nbsp;", ""));
				text = decodeURI(encodeURI(text).replace(/%E2%80%8B/g, "")); //&#8203;没被Trim掉 不能放过
				if(text.length == 0 && !hasSingleLine(curNode)) {
					deleteNode = curNode;
				}

			}
		}

		if(deleteNode && deleteNode.tagName && deleteNode.tagName.toLowerCase() != "body") {
			removeNodeList.push(deleteNode);
			//alert("删除尾部节点" + deleteNode.innerHTML);
			//几个兄弟是否能删除
			curNode = deleteNode.previousSibling;
			while(curNode) {
				//alert("有兄弟");
				text = Trim(getInnerText(curNode).replaceAll("&nbsp;", ""));
				if(text.length == 0 && !hasSingleLine(curNode) && curNode.tagName && curNode.tagName.toLowerCase() != "body") {
					removeNodeList.push(curNode);
					//alert("删除兄弟节点" + curNode.innerHTML);
					curNode = curNode.previousSibling;
				} else {
					break;
				}
			}
		}
	} catch(err) {
		try {
			console.log(err)
		} catch(e) {}
		//房蕾的QQ浏览器IE模式始终会进catch 暂时去掉alert有时间再查找
		//alert(err);
	}
}
function Trim(str) {
	return str.replace(/(^\s*)|(\s*$)/g, "");
}
//节点是否包含占行节点
function hasSingleLine(curNode) {
	if(isNode(curNode, "img") || isNode(curNode, "embed") || isNode(curNode, "object") || isNode(curNode, "input") || isNode(curNode, "iframe") || isNode(curNode, "video") || isNode(curNode, "audio") || isNode(curNode, "hr")) {
		return true;
	} else if(hasChildNode(curNode, "img") || hasChildNode(curNode, "embed") || hasChildNode(curNode, "object") || hasChildNode(curNode, "input") || hasChildNode(curNode, "iframe") || hasChildNode(curNode, "video") || hasChildNode(curNode, "audio") || hasChildNode(curNode, "hr")) {
		return true;
	}
	return false;
}
//节点是否是占行节点，不能删除
function isSingleLine(curNode) {
	if(isNode(curNode, "img") || isNode(curNode, "embed") || isNode(curNode, "object") || isNode(curNode, "input") || isNode(curNode, "iframe") || isNode(curNode, "video") || isNode(curNode, "audio") || isNode(curNode, "hr")) {
		//alert("自己是占行节点！" + curNode.tagName);
		return true;
	}
	return false;
}

function isNode(node, tag) {
	if(node && node !== "undefined" && node.nodeType == 1 && node.tagName && node.tagName.toLowerCase() == tag)
		return true;
	else
		return false;
}

function hasChildNode(node, tag) {
	var lenc;
	try {
		if(node && node !== "undefined" && node.nodeType == 1) {
			lenc = node.getElementsByTagName(tag);
			if(lenc != null && lenc.length > 0) {
				return true;
			}
		}
		return false;
	} catch(err) {
		//alert(err + " node:" + node.outerHTML);
		return false;
	}

}
String.prototype.replaceAll = function(A, B) {
	var C = this;
	for(var i = 0; i < A.length; i++) {
		C = C.replace(A[i], B[i]);
	};
	return C;
};
String.prototype.getAttr=function (attrName) {
	return this.attrs && this.attrs[attrName.toLowerCase()]
}