function ArtImgManager() {
	var _This = this;
	var _Pathes;
	var _HiddenDiv;
	var _LoadingImg1;
	var _LoadingImg2;

	var iCurrImg = -1;

	ArtImgManager.prototype.InitImgPath = function(imgPath) {
		try {

			//AliansBridge.JSLOG("imgPath:" + imgPath);
			_Pathes = imgPath.split(',');
		} catch (e) {
			_Pathes = null;
		}
	}
	ArtImgManager.prototype.StartLoadImages = function() {
		//AliansBridge.JSLOG("imgPath:" + "_Pathes.length:" + _Pathes.length);
		if (_Pathes != null && _Pathes.length > 0) {
			_initImageObj();
			_loadNextImage(1);
			_loadNextImage(2);
		}
	}

	function _initImageObj() {

		try {
			_HiddenDiv = document.createElement("DIV");
			_HiddenDiv.className = "imgHide";
			document.body.appendChild(_HiddenDiv);

			_LoadingImg1 = document.createElement("IMG");
			_LoadingImg1.onload = function() {
				var iLoadingID1 = _LoadingImg1.id.replace("loadingimg", "");
				ShowSingleImage("img" + iLoadingID1, _LoadingImg1.src);
				_loadNextImage(1);
			}
			_LoadingImg1.onerror = function() {
				_loadNextImage(1);
			};

			_LoadingImg2 = document.createElement("IMG");
			_LoadingImg2.onload = function() {
				var iLoadingID2 = _LoadingImg2.id.replace("loadingimg", "");
				ShowSingleImage("img" + iLoadingID2, _LoadingImg2.src);
				_loadNextImage(2);
			}
			_LoadingImg2.onerror = function() {
				_loadNextImage(2);
			};

			_HiddenDiv.appendChild(_LoadingImg1);
			_HiddenDiv.appendChild(_LoadingImg2);
		} catch (e) {

		}
	}

	function _loadNextImage(loadingID) {
		try {
			iCurrImg++;
			if (iCurrImg < _Pathes.length) {
				switch (loadingID) {
				case 1:
					_LoadingImg1.id = "loadingimg" + iCurrImg;
					_LoadingImg1.src = _Pathes[iCurrImg];
					break;
				case 2:
					_LoadingImg2.id = "loadingimg" + iCurrImg;
					_LoadingImg2.src = _Pathes[iCurrImg];
					break;
				}
			}
		} catch (e) {
		}
	}
}

function ShowSingleImage(imgid, imgsrc) {
	try {
		//AliansBridge.JSLOG("imgPath" + "ShowSingleImage:" + imgid + "==imgsrc:"	+ imgsrc);
		if (document.getElementById(imgid) != null && imgsrc!="-1") {
			
			document.getElementById(imgid).src = imgsrc;

		}
	} catch (e) {
	}
}