var editor,blurTimer;
var readOnly = parent.ZSSEditor ? true : false;
var ltoolbar = false,options,
	lanlist = ["C", "C++", "C#", "CSS", "Dart", "Diff", "Erlang", "GO", "HTML", "Java", "JavaScript", "JSON", "Markdown", "Objective-C", "Plain-Text", "Perl", "PHP", "PowerShell", "Python", "Ruby", "SQL", "Swift", "VB.NET", "XML"];
	var modelist=['text/x-csrc','text/x-c++src','text/x-csharp','text/css','application/dart','text/x-diff','text/x-erlang','text/x-go','text/html','text/x-java','text/javascript','application/json','text/x-markdown','text/x-objectivec','text/text','text/x-perl','text/x-php','application/x-powershell','text/x-python','text/x-ruby','text/x-sql','text/x-swift','text/x-vb','application/xml'];
	function getModeText(lantext){
		var l='text/javascript';
		for(var i=0;i<lanlist.length;i++){
			if(lanlist[i].toLowerCase()==lantext.toLowerCase()){
				l=modelist[i];break
			}
		};
		if(lantext=='none'){
			return 'text/text'
		}
		return l
	}
	function getLanText(modetext){
		var l='javascript';
		for(var i=0;i<modelist.length;i++){
			if(modelist[i].toLowerCase()==modetext.toLowerCase()){
				l=lanlist[i];break
			}
		};
		return l
	}
var myframe = (function() {
		var iframes = parent.document.getElementsByTagName('iframe'),
			targ;
		for(var i = 0; i < iframes.length; i++) {
			if(iframes[i].contentWindow == window) {
				targ = iframes[i];
				break
			}
		};
		return targ
	})();
$(function() {
	var codebox = document.getElementById('code');
	editor = CodeMirror.fromTextArea(codebox, {
		mode: getModeText(window.clang), //编辑器语言
		lineNumbers: true,
		autofocus: !!window.fs,
		theme: window.ctheme ? window.ctheme : 'neo',
		styleActiveLine: readOnly,
		smartIndent: true,
		matchBrackets: readOnly,
		readOnly: !readOnly
	});
    setTimeout(function(){
        $(".CodeMirror-code").removeAttr("contenteditable");
        $(".CodeMirror-line-like").text("");
        $(myframe).before($(".CodeMirror ")[0].outerHTML);
        $(myframe).remove();
    },100);
	editor.on('blur', function() {
		if(readOnly) {
		    var codes = editor.getValue();
            var mode = editor.options.mode;
            var theme = editor.options.theme;

            myframe.setAttribute('cm-code', codes);
            myframe.setAttribute('cm-theme', theme);
            myframe.setAttribute('cm-mode', getLanText(mode));
			//uedt.setEnabled()
		}
	});
	editor.on('focus', function() {options&&options.remove();
		if(readOnly) {
			//uedt.setDisabled()
		};

	});
	editor.on('viewportChange', function(edt, b, linenumber) {
		myframe.setAttribute('height', $('body').height());
		//options&&options.css('height',$(window).height()-2);
		//uedt && uedt.fireEvent('contentchange');
	});
	myframe.setAttribute('height', $('body').height());
	//uedt && uedt.fireEvent('contentchange');
	$(window).focus(function() {
		if(readOnly) {
			//uedt.setDisabled();
		};
		ltoolbar&&ltoolbar.show();
	});
	$(window).blur(function(e) {
		if(readOnly) {
			//uedt.setEnabled()
		};
		ltoolbar&&ltoolbar.hide();
		clearTimeout(blurTimer)
		blurTimer=setTimeout(function(){options&&options.remove();},100)
	});
    $(".CodeMirror-scroll").scroll(function() {
        parent.AliansBridge.parentsCanScroll(0);
    });
	$(".CodeMirror-scroll").on("touchstart",function() {
        parent.AliansBridge.interruptViewPagerScroll(1);
    });
    $(".CodeMirror-scroll").on("touchend",function() {
        parent.AliansBridge.interruptViewPagerScroll(0);
    });
    $(".CodeMirror-scroll").on("touchcancel",function() {
        parent.AliansBridge.interruptViewPagerScroll(0);
    });
	if(readOnly) {
		ltoolbar = $('<div/>').addClass('lan-select').attr('id', 'lan-select').html('<div>' + (window.clang=='none'?'选择语言':window.clang) + '</div>');
		$('body').append(ltoolbar);
		ltoolbar.click(function() {
			clearTimeout(blurTimer);
			if(!top.document.getElementById('for_code_lanselect')){
				var fcl = document.createElement('style');
				fcl.id='for_code_lanselect';
        fcl.type = 'text/css';
        fcl.innerHTML=".lan-options{position:absolute;z-index:1000;width:120px;height:162px;top:0;left:0;background:#fff;cursor:pointer;border:solid 1px #eaeaea;border-top:none;border-right:none;overflow:auto;}.lan-options a{display:block;color:#333;font-size:14px;height:27px;line-height:27px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;text-indent:10px;cursor:pointer;}.lan-options a:hover{background:#eee;}";
        top.document.getElementsByTagName('head')[0].appendChild(fcl);
			};
			if(!options){
				options=$('<div class="lan-options"/>');var strs='';
				options[0].ifr=myframe;
				for(var i=0;i<lanlist.length;i++){
				strs+='<a href="#">'+lanlist[i]+'</a>';
				};
				options.html(strs);
			};
			var pos=getMyPos();
			options.css({left:pos.x,top:pos.y}).appendTo(top.document.body);

			options.find('a').unbind().click(function(e){
					e.stopPropagation();
					e.preventDefault();
					var taglan=$(this).html();
					options.remove();
					ltoolbar.find('div').html(taglan);
					editor.setOption('mode',getModeText(taglan));
					window.clang=taglan;
					myframe.setAttribute('cm-mode', taglan);
					editor.focus()
				});
		});
	}
});
function getMyPos(){
	var ow=window,
		oifr=myframe,
		x=$('#lan-select').offset().left,
		y=$('#lan-select').offset().top;
	while (ow.parent!=ow){
		ow=ow.parent;
		x+=$(oifr).offset().left;
		y+=$(oifr).offset().top;
		oifr=(function() {
		var iframes = ow.parent.document.getElementsByTagName('iframe'),
			targ;
			for(var i = 0; i < iframes.length; i++) {
				if(iframes[i].contentWindow == ow) {
					targ = iframes[i];
					break
				}
			};
			return targ
		})();
	}
	return {'x':x,'y':y}
}
