﻿var AppearIndex;
var originalArticleContentHTML;
var highLightStartIndex;
var highLightEndIndex;
var whitespace = ' \n\r\t\f            ​';

//文章页高亮显示标记和批注
function showAllHighlightsApp(jsonStr, isArticleOwner) {
    try {

        var jsonObj = JSON.parse(jsonStr);
        artcontent = document.getElementById("artcontent").innerHTML;
        var iNum = 0;
        for (var i = 0; i < jsonObj.length; i++) {
            if (iNum != 0) {
                artcontent = document.getElementById("artcontent").innerHTML
            };
            var HighlightID = jsonObj[i]["highlightid"];
            var TargetContent = jsonObj[i]["targetcontent"];
            if (TargetContent.indexOf("@360docjia@") > -1) {
                TargetContent = TargetContent.replace(/(@360docjia@)/g, '+')
            };
            var AppearIndex = jsonObj[i]["appearindex"];
            var StickyCount = jsonObj[i]["stickycount"];
            var lightloca = -1;
            var IsNewHighlight = true;
            var redDotID = "";
            var redDot = "";
            do {
                if (IsNewHighlight) {
                    TargetContent = TargetContent.replace(/(@360doca@)/g, '').replace(/(@360docd@)/g, '').replace(/()/g, '').replace(/(&nbsp;)/g, '').replace(/(' ')/g, '');
                    IsNewHighlight = false
                } else {
                    TargetContent = TargetContent.replace(/(@360doca@)/g, '').replace(/(@360docd@)/g, '').replace(/()/g, '').replace(/(&nbsp;)/g, '').replace(/(' ')/g, '');
                    IsNewHighlight = true
                }
                lightloca = findIndex(artcontent, TargetContent, AppearIndex)
            } while (lightloca.lightstart == -1 && !IsNewHighlight);
            if (lightloca.lightstart > -1) {
                iNum++;
                TargetContent = artcontent.substring(lightloca.lightstart, lightloca.lightend + 1);
                var emid = "highlight_" + HighlightID;
                redDotID = "highlight_reddot_" + HighlightID;
                var specialAttr = "data-highlightid=" + HighlightID;
                var mark;
                if (StickyCount > 0) {
                    if (StickyCount > 99) {
                        StickyCount = 99;
                    }
                    //当前标记有批注
                    if (isArticleOwner == 0) {
                        //非文章作者自己观看
                        mark = '<span class="sticky" id="' + emid + '" ' + specialAttr + ' onclick="showStickyOther(' + HighlightID + ')" >'
                    } else if (isArticleOwner == 1) {
                        //文章作者自己观看
                        mark = '<span class="sticky" id="' + emid + '"  ' + specialAttr + ' onclick="showOperateLayer(' + HighlightID + ')" >';
                    }
                    redDot = '<span id="' + redDotID + '" class="highlightreddot" style="width: 0.9rem;height:0.9rem;position: absolute;border-radius: 50%;background: #ff3b30;font-size: 0.5rem;line-height: 0.9rem;text-align: center;color: #fff;font-style: normal;margin-left:-0.2rem;letter-spacing: 0;bottom:0;text-indent:0;">' + StickyCount + '</span>';

                } else {
                    var testclassname = "samehighid_" + HighlightID;
                    //当前标记无批注
                    if (isArticleOwner == 0) {
                        //非文章作者自己观看
                        mark = '<span class="highlight" id="' + emid + '"  ' + specialAttr + '  >'
                    } else if (isArticleOwner == 1) {
                        //文章作者自己观看
                        mark = '<span class="highlight" id="' + emid + '"  ' + specialAttr + '   onclick="showOperateLayer(' + HighlightID + ')">'
                    }
                    redDot = '<span id="' + redDotID + '" class="highlightreddot" style="display:none;width: 0.9rem;height:0.9rem;position: absolute;border-radius: 50%;background: #ff3b30;font-size: 0.5rem;line-height: 0.9rem;text-align: center;color: #fff;font-style: normal;margin-left:-0.2rem;letter-spacing: 0;bottom:0;text-indent:0;"></span>';

                };
                var before = artcontent.substring(0, lightloca.lightstart);
                var after = artcontent.substring(lightloca.lightend + 1);
                var markTarget = insertMark(TargetContent, mark, '</span>');
                var strNew = before + markTarget + after;
                strNew = strNew.replace(/(@360doca@)/g, '');
                strNew = strNew.replace(/(@360docd@)/g, '');
                artcontent = strNew;
                document.getElementById("artcontent").innerHTML = artcontent;
                var highlightNew2 = $('span[id=highlight_' + HighlightID + ']:last');
                if (highlightNew2 != null) {
                    highlightNew2.append(redDot);
                }

            }
        }
        resizeReddotSize();
    }
    catch (e) {

    }
};

//调用原生显示提示框
function showAlert(text) {
    try {
        if (isAndroid()) {
            AliansBridge.showHighlightAlert(text);
        }
        else {
            jsBridge.callHandler('showHighlightAlert', { "text": text }, function (response) { });
        }
    }
    catch (e)
    { }
}

//隐藏显示的操作层
function hideHightLightLayer() {
    try {
        $('.editMenu').hide();
    }
    catch (e)
    { }

}

//显示批注、标记操作层 type：1标记 2批注
function showOperateLayer(HighlightID) {
    try {
        var operateLayerWidth;
        var type;
        var high = $('#highlight_' + HighlightID);
        if (high.hasClass('sticky')) {
            type = 2;
        }
        else {
            type = 1;
        }
        if (type == 1) {
            //标记，显示两个按钮（删除标记、添加批注）
            operateLayerWidth = 162;
            $('.editMenu a').eq(2).hide();
            $('.editMenu a').eq(1).addClass("circle");
        }
        else if (type == 2) {
            //批注，显示三个按钮（删除标记、添加批注、查看批注）
            operateLayerWidth = 243;
            $('.editMenu a').eq(2).show();
            $('.editMenu a').eq(1).removeClass("circle");
        }
        var highLight = $('#highlight_' + HighlightID);//获取标记、批注对象
        var highLightTop = highLight.offset().top;//标记、批注对象距顶部距离
        var highLightLeft = highLight.offset().left;//标记、批注对象距离左边距离
        var highLightHeight = highLight.height();//标记、批注对象高度
        var highLightWidth = highLight.width();//标记、批注对象宽度
        var operateLayerTop;//操作按钮层距离顶部距离
        //计算操作按钮层距离顶部距离
        operateLayerTop = highLightTop - 36 - 2;
        if (operateLayerTop < 0) {
            operateLayerTop = highLightTop + highLightHeight + 2;
        }
        //计算操作按钮层距离左边距离
        var operateLayerLeft;//操作按钮层距离左边距离
        operateLayerLeft = highLightLeft - (operateLayerWidth - highLightWidth) / 2;
        if (operateLayerLeft < 0) {
            operateLayerLeft = highLightLeft;
        }
        if ((operateLayerLeft + operateLayerWidth) > $('body').width()) {
            operateLayerLeft = $('body').width() - operateLayerWidth - 15;
        }
        //显示操作按钮层
        $('.editMenu').css({
            "top": operateLayerTop,
            "left": operateLayerLeft,
            "width": operateLayerWidth,
        }).show().attr("currentHighlightID", HighlightID);
        if (isAndroid()) {
            AliansBridge.tracking("52-3-54");
        }
        else {
            jsBridge.callHandler('trackCode', { "code": "47-3-54" }, function (response) { });
        }
    }
    catch (e)
    { }
}

//获取某标记对应文本内容
function getHighlightContent(HighlightID) {
    var targetcontent = "";
    try {
        var specialArrt = "data-highlightid=" + HighlightID;
        $('span[' + specialArrt + ']').each(function () {
            var obj = $(this);//红点
            var temptargetContent = "";
            var html = obj.html();
            if (html.indexOf("highlight_reddot_") > -1) {
                try {
                    var divObj = document.createElement("div");
                    divObj.innerHTML = html;
                    $(divObj).find(">span").remove();
                    temptargetContent = $(divObj).text();
                }
                catch (e) {
                    temptargetContent = "";
                }
                if (temptargetContent == null) {
                    temptargetContent = "";
                }
                targetcontent += temptargetContent;
            }
            else {
                targetcontent += html;
            }

        });
    }
    catch (e) {
        targetcontent = "";
    }
    return targetcontent;
}

//添加批注
function addSticky() {
    try {
        //调用原生方法，显示添加批注层
        var HighlightID = $('.editMenu').attr("currentHighlightID");
        var targetContent = "";
        targetContent = getHighlightContent(HighlightID);
        if (targetContent == null || targetContent == "") {
            var divObj = document.createElement("div");
            divObj.innerHTML = document.getElementById("highlight_" + HighlightID).outerHTML;
            $(divObj).find(">span span").remove();
            targetContent = $(divObj).text();
        }
        if (targetContent == null) {
            targetContent = "";
        }
        if (isAndroid()) {
            targetContent = targetContent.replace(/(@360docjia@)/g, '+').replace(/(&nbsp;)/g, '');
            AliansBridge.addSticky(HighlightID, targetContent);
            AliansBridge.tracking("52-3-56");
        }
        else {
            jsBridge.callHandler('addSticky', { "highlightid": HighlightID, "targetcontent": targetContent }, function (response) { });
            jsBridge.callHandler('trackCode', { "code": "47-3-56" }, function (response) { });
        }
    }
    catch (e)
    { }
}

//查看批注
function showSticky() {
    try {
        //调用原生方法，显示所有批注
        var HighlightID = $('.editMenu').attr("currentHighlightID");
        if (isAndroid()) {
            AliansBridge.showSticky(HighlightID);
            AliansBridge.tracking("52-3-57");
        }
        else {
            jsBridge.callHandler('showSticky', { "highlightid": HighlightID }, function (response) { });
            jsBridge.callHandler('trackCode', { "code": "47-3-57" }, function (response) { });
        }
    }
    catch (e)
    { }
}

//查看他人批注
function showStickyOther(HighlightID) {
    try {
        //调用原生方法，显示所有批注
        if (isAndroid()) {
            AliansBridge.showSticky(HighlightID);
            AliansBridge.tracking("52-3-54");
        }
        else {
            jsBridge.callHandler('showSticky', { "highlightid": HighlightID }, function (response) { });
            jsBridge.callHandler('trackCode', { "code": "47-3-54" }, function (response) { });
        }
    }
    catch (e)
    { }
}

//删除标记
function deleteHighlight() {
    try {
        //调用原生方法，弹框确认并删除标记
        var HighlightID = $('.editMenu').attr("currentHighlightID");
        var isStick;
        var high = $('#highlight_' + HighlightID);
        if (high.hasClass('sticky')) {
            isStick = 2;
        }
        else {
            isStick = 1;
        }

        if (isAndroid()) {
            AliansBridge.deleteHighlight(HighlightID, isStick);
            AliansBridge.tracking("52-3-55");
        }
        else {
            jsBridge.callHandler('deleteHighlight', { "highlightid": HighlightID, "type": isStick }, function (response) { });
            jsBridge.callHandler('trackCode', { "code": "47-3-55" }, function (response) { });
        }
    }
    catch (e)
    { }

}

function FindAppearIndex(markarticle, selectiontext, pos) {
    var appearindex = 1;
    var searchstart = 0;
    while (searchstart < markarticle.length) {
        index = markarticle.indexOf(selectiontext, searchstart);
        if (index == -1) {
            showAlert("标记内容含有特殊字符，无法操作");
            appearindex = 0;
            break
        } else if (index > pos) {
            break
        } else {
            searchstart = index + 1;
            appearindex++
        }
    };
    return appearindex
};
function subnodesExcept(str, mark) {

    var str = str.replace(/(|)/g, '');
    var markpos = str.indexOf(mark);
    if (markpos != -1) {
        var beforestr = str.substring(0, markpos);
        var afterstr = str.substring(markpos + mark.length);
        var result = subnodes(beforestr) + mark + subnodes(afterstr);
        return result
    } else {
        return subnodes(str)
    }
};
function subnodes(str) {
    var result = "";
    var start = 0;
    var end = -1;
    for (i = 0; i < str.length; i++) {
        if (str.charAt(i) == '<') {
            end = i;
            result += str.substring(start, end);
            start = i
        } else if (str.charAt(i) == '>') {
            if (start == end) {
                start = i + 1
            }
        }
    };
    if (start < str.length) {
        result += str.substring(start)
    };
    return result
};
function subHeadTailNode(str) {
    str = str.replace(/(|)/g, '');
    var start = -1;
    var head = "";
    for (var i = 0; i < str.length; i++) {
        if (str.charAt(i) == '<') {
            start = i
        } else if (start > -1 && str.charAt(i) == '>') {
            head += str.substring(start, i + 1);
            start = -1
        } else if (start == -1 && str.charAt(i) != '<') {
            break
        }
    };
    rest = str.substring(i);
    var end = -1;
    var tail = "";
    for (var i = rest.length - 1; i >= 0; i--) {
        if (rest.charAt(i) == '>') {
            end = i
        } else if (end > -1 && rest.charAt(i) == '<') {
            tail += rest.substring(i, end + 1);
            end = -1
        } else if (end == -1 && rest.charAt(i) != '>') {
            break
        }
    };
    rest = rest.substring(0, i + 1);
    return rest
};
function onFailed() { };
var trim = function (strs) {
    var newstr = '';
    var str = strs;
    for (var i = 0; i < str.length; i++) {
        if (whitespace.indexOf(str.charAt(i)) === -1) {
            newstr += str.charAt(i)
        }
    };
    return newstr
};
function insertMark(str, startmark, endmark) {
    str = startmark + str;
    var i = startmark.length;
    while (i < str.length) {
        if (str.charAt(i) == '<' && str.charAt(i - 1) != '>') {
            beforestr = str.substring(0, i);
            afterstr = str.substring(i);
            str = beforestr + endmark + afterstr;
            i += endmark.length
        } else if (str.charAt(i) == '>' && str.charAt(i + 1) != '<') {
            beforestr = str.substring(0, i + 1);
            afterstr = str.substring(i + 1);
            str = beforestr + startmark + afterstr;
            i += startmark.length
        }
        i++
    }
    str = str + endmark;
    return str
};
function findIndex(article, targetcontent, AppearIndex) {
    return Index(article, targetcontent, AppearIndex, 0)
};
function Index(article, targetcontent, AppearIndex, pos) {
    var startindex = -1,
		endindex = -1;
    var i = pos;
    var j = 0;
    var artlen = article.length;
    var targetlen = targetcontent.length;
    var readable = true;
    var result;
    var isBMbug = false;
    if (article.indexOf("�") == -1 && targetcontent.indexOf("�") > -1) {
        isBMbug = true
    }
    while (i < artlen && j < targetlen) {
        if (article.charAt(i) == '>') {
            readable = true;
            i++
        }
        if (article.charAt(i) == '<') {
            readable = false
        }
        if (readable == true) {
            if (j == 0) {
                startindex = i
            }
            if (article.charAt(i) == targetcontent.charAt(j)) {
                i++;
                j++
            } else if (isBMbug && targetcontent.charAt(j) == "�") {
                i++;
                j++
            } else if (article.charAt(i) == "+" && targetcontent.charAt(j) == " ") {
                i++;
                j++
            } else if (article.charAt(i) == '' || article.charAt(i) == ' ' || article.charAt(i) == ' ' || whitespace.indexOf(article.charAt(i)) > -1 || article.charAt(i) == '&nbsp;' || article.charAt(i) == '&nbsp') {
                i++
            } else if (article.charAt(i) == '&' && i + 6 <= artlen && article.charAt(i + 1) == 'n' && article.charAt(i + 2) == 'b' && article.charAt(i + 3) == 's' && article.charAt(i + 4) == 'p' && article.charAt(i + 5) == ';') {
                i = i + 6;
                while (article.charAt(i) == '&' && i + 6 <= artlen && article.charAt(i + 1) == 'n' && article.charAt(i + 2) == 'b' && article.charAt(i + 3) == 's' && article.charAt(i + 4) == 'p' && article.charAt(i + 5) == ';') {
                    i = i + 6
                }
            } else {
                if (article.charAt(i) == targetcontent.charAt(0)) {
                    startindex = i;
                    j = 1
                } else {
                    j = 0
                }
                i++
            }
        } else {
            i++
        }
    }
    if (j >= targetlen) {
        endindex = i - 1;
        AppearIndex--;
        if (AppearIndex == 0) {
            result = {
                lightstart: startindex,
                lightend: endindex
            };
            return result
        } else {
            return Index(article, targetcontent, AppearIndex, startindex + 1)
        }
    } else {
        result = {
            lightstart: -1,
            lightend: -1
        };
        return result
    }
};
function trim(str) {
    if (typeof str != "string") {
        return str
    } else {
        return str.replace(/^\s+/, '').replace(/\s+$/, '')
    }
};

//添加标记
function addHighlight() {
    try {
        var selhtml;
        var seltext;
        var testContent1 = "";
        var testContent2 = "";
        var testContent3 = "";
        var testContent4 = "";
        var targetcontent = "";
        originalArticleContentHTML = document.getElementById("artcontent").innerHTML;
        if (window.getSelection) {
            var selection = window.getSelection();
            var range;
            try {
                range = selection.getRangeAt(0)
            } catch (e) {
                range = "";
            }
            var rangestart = document.createElement("span");
            rangestart.id = "rangeStart";
            try {
                range.surroundContents(rangestart);
                if (document.getElementById("rangeStart").innerHTML == "") {
                    var content = range.extractContents();
                    document.getElementById("rangeStart").innerHTML = content.textContent;
                }
            } catch (e) {
                var content = range.extractContents();
                if (content != null) {
                    var childerens = content.children;
                    if (childerens != null && childerens.length > 0) { } else {
                        childerens = content.childNodes
                    };
                    if (childerens != null) {
                        $.each(childerens, function (index1, value1) {
                            if (value1.outerHTML == null) {
                                testContent1 += value1.nodeValue
                            } else {
                                testContent1 += value1.outerHTML
                            }
                        });
                    }
                };
                var span = document.createElement("span");
                span.id = "rangeStart";
                span.innerHTML = content.textContent;
                range.deleteContents();
                range.insertNode(span)
            }
            var rangeStart = $('#rangeStart');
            if (testContent2 == "") {
                testContent2 = rangeStart.html()
            };
            if (testContent2 == "") {
                //调用原生方法弹框，结束流程
                showAlert("标记内容为空，无法操作");
                return;
            };
            if (testContent1 != "" && (testContent1.indexOf("class=\"highlight\"") > -1 || testContent1.indexOf("class='highlight'") > -1 || testContent1.indexOf("class=highlight") > -1 || testContent1.indexOf("class=\"sticky\"") > -1 || testContent1.indexOf("class='sticky'") > -1 || testContent1.indexOf("class=sticky") > -1)) {
                //所选文字包含一部分标记或者批注，调用原生方法弹框，结束流程
                showAlert("不能在标记上添加新的标记或批注");
                document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                return;
            };
            if (testContent2.indexOf("class=\"highlight\"") > -1 || testContent2.indexOf("class='highlight'") > -1 || testContent2.indexOf("class=highlight") > -1 || testContent2.indexOf("class=\"sticky\"") > -1 || testContent2.indexOf("class='sticky'") > -1 || testContent2.indexOf("class=sticky") > -1) {
                //所选文字包含完整的标记或者批注，调用原生方法弹框，结束流程
                showAlert("不能在标记上添加新的标记或批注");
                document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                return;
            };
            testContent3 = rangeStart.html();
            if (testContent3.indexOf("class='highlight'") > -1 || testContent3.indexOf("class=highlight") > -1 || testContent3.indexOf("class='sticky'") > -1 || testContent3.indexOf("class=sticky") > -1) {
                //调用原生方法弹框，结束流程
                showAlert("不能在标记上添加新的标记或批注");
                document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                return;
            } else {
                if ($('#rangeStart').length > 0 && ($('#rangeStart').parent()[0].className == "highlight" || $('#rangeStart').parent()[0].className == "sticky")) {
                    //调用原生方法弹框，结束流程
                    showAlert("不能在标记上添加新的标记或批注");
                    document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                    return;
                }

            };
            targetcontent = document.getElementById("rangeStart");
            selhtml = targetcontent.innerHTML;
            testContent4 = selhtml
        } else if (document.selection) {

            var selectrange = document.selection.createRange();
            if (selectrange != null) {
                selhtml = selectrange.htmlText;
                try {
                    selectrange.pasteHTML('<SPAN id=rangeStart>' + selhtml + '</SPAN>')
                } catch (e) {
                    selectrange.text = "";
                    try {
                        selectrange.pasteHTML('<SPAN id=rangeStart>' + selhtml + '</SPAN>')
                    } catch (e2) {
                        //调用原生方法弹框，结束流程
                        showAlert("标记内容含有特殊字符，无法操作");
                        document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                        return;
                    }
                }
            }
        };

        var markarticle = document.getElementById("artcontent").innerHTML.replace(/(|)/g, '');
        var startmark = '<SPAN id=rangeStart>';
        var rangestartindex = markarticle.indexOf(startmark);
        if (rangestartindex != -1) {
            markarticle = subnodesExcept(markarticle, '<SPAN id=rangeStart>');
            rangestartindex = markarticle.indexOf(startmark)
        } else {
            startmark = '<span id="rangeStart">';
            markarticle = subnodesExcept(markarticle, '<span id="rangeStart">');
            rangestartindex = markarticle.indexOf(startmark)
        };
        var target = document.getElementById("rangeStart").innerHTML.replace(/(|)/g, '');
        target = subHeadTailNode(target);
        target = subnodes(target);
        AppearIndex = FindAppearIndex(markarticle, target, rangestartindex);
        if (AppearIndex > 0) {
            newhighlight = false;
            seltext = trim(subnodes(selhtml.trim()).replace(/()/g, '')).replace(/(&nbsp;)/g, '');
            var lightloca = -1;
            lightloca = findIndex(originalArticleContentHTML, seltext, AppearIndex);
            if (lightloca.lightstart == -1) {
                //调用原生方法弹框，结束流程
                showAlert("标记内容含有特殊字符，无法操作");
                document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                return;

            };

            //获取所选内容文字
            TargetContent = seltext
            if (TargetContent.indexOf("+") > -1) {
                TargetContent = TargetContent.replace(/(\+)/g, '@360docjia@')
            };
            //计算开始、结束索引位置
            highLightStartIndex = lightloca.lightstart;
            highLightEndIndex = lightloca.lightend;


            //调用接口
            if (testContent4.indexOf('<span class=highlight id=highlight_') == -1 && testContent4.indexOf('<span class=sticky id=highlight_') == -1 && testContent4.indexOf('<span class="highlight" id="highlight_') == -1 && testContent4.indexOf('<span class="sticky" id="highlight_') == -1 && testContent4.indexOf('<span class=highlight') == -1 && testContent4.indexOf('<span class=sticky') == -1 && testContent4.indexOf('<span class="highlight"') == -1 && testContent4.indexOf('<span class="sticky"') == -1) {
                if (TargetContent == null || TargetContent == "") {
                    //调用原生方法弹框，结束流程
                    showAlert("标记内容为空，无法操作");
                    document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                    newhighlight = true;
                    return;
                };


                var targethtml = originalArticleContentHTML.substring(lightloca.lightstart, lightloca.lightend + 1);
                var before = originalArticleContentHTML.substring(0, lightloca.lightstart);
                var after = originalArticleContentHTML.substring(lightloca.lightend + 1);
                var markTarget = insertMark(targethtml, '<span data-prehighlight=1>', '</span>');
                var strNewContent = before + markTarget + after;
                strNewContent = strNewContent.replace(/(@360doca@)/g, '');
                strNewContent = strNewContent.replace(/(@360docd@)/g, '');
                document.getElementById("artcontent").innerHTML = strNewContent;
                TargetContent = TargetContent.replace(/(@360docjia@)/g, '+').replace(/(&nbsp;)/g, '');
                if (isAndroid()) {
                    AliansBridge.addHighlight(AppearIndex, TargetContent);
                }
                else {
                    jsBridge.callHandler('addHighlight', { "apperindex": AppearIndex, "targetcontent": TargetContent }, function (response) { });
                }
            } else {
                //调用原生方法弹框，结束流程
                showAlert("不能在标记上添加新的标记或批注");
                document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
                newhighlight = true;
                return;
            }
        }
    }
    catch (e)
    { }
}

//成功添加标记后刷新UI备份
function successAddHighLightRefreshUIBackup(highlightid) {
    try {
        var testContent = "";
        var rangeStart = document.getElementById("rangeStart");
        if (rangeStart == null) {
            return;
        }
        testContent = rangeStart.innerHTML;
        if (originalArticleContentHTML == null || originalArticleContentHTML.length == 0) {
            return;
        }
        //调用成功后处理UI
        if (testContent.indexOf('<span class=highlight id=highlight_') == -1 && testContent.indexOf('<span class=sticky id=highlight_') == -1 && testContent.indexOf('<span class="highlight" id="highlight_') == -1 && testContent.indexOf('<span class="sticky" id="highlight_') == -1 && testContent.indexOf('<span class=highlight') == -1 && testContent.indexOf('<span class=sticky') == -1 && testContent.indexOf('<span class="highlight"') == -1 && testContent.indexOf('<span class="sticky"') == -1) {
            if (highLightStartIndex != null && highLightStartIndex > -1 && highLightEndIndex != null && highLightEndIndex > -1) {
                var targetHtml = originalArticleContentHTML.substring(highLightStartIndex, highLightEndIndex + 1);;
                var beforeHtml = originalArticleContentHTML.substring(0, highLightStartIndex);
                var afterHtml = originalArticleContentHTML.substring(highLightEndIndex + 1);
                var redDotID = "highlight_reddot_" + highlightid;
                var redDot = "";
                var emid = "highlight_" + highlightid;
                var specialAttr = "data-highlightid=" + highlightid;
                redDot = '<span id="' + redDotID + '" class="highlightreddot" style="display:none;width: 0.9rem;height:0.9rem;position: absolute;border-radius: 50%;background: #ff3b30;font-size: 0.5rem;line-height: 0.9rem;text-align: center;color: #fff;font-style: normal;margin-left:-0.2rem;letter-spacing: 0;bottom:0;text-indent:0;"></span>';
                var markTarget = insertMark(targetHtml, '<span class="highlight" id="' + emid + '"  ' + specialAttr + '   onclick="showOperateLayer(' + highlightid + ')">', '</span>');
                var strNewContent = beforeHtml + markTarget + afterHtml;
                strNewContent = strNewContent.replace(/(@360doca@)/g, '');
                strNewContent = strNewContent.replace(/(@360docd@)/g, '');
                document.getElementById("artcontent").innerHTML = strNewContent;
                var highlightNew2 = $('span[id=highlight_' + highlightid + ']:last');
                if (highlightNew2 != null) {
                    highlightNew2.append(redDot);
                }
                resizeReddotSize();
            }
            else {
                //还原正文内容
                document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
            }
        } else {
            //还原正文内容
            document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
        };
    }
    catch (e) {
    }
}

//成功添加标记后刷新UI
function successAddHighLightRefreshUI(highlightid) {
    try {

        //调用成功后处理UI
        //处理标记内容变为标记样式
        var emid = "highlight_" + highlightid;
        var specialAttr = "data-highlightid=" + highlightid;
        artcontent = document.getElementById("artcontent").innerHTML;
        if (artcontent.indexOf('<span data-prehighlight=1>') != -1) {
            artcontent = artcontent.replace(/<span data-prehighlight=1>/g, '<span class="highlight" id="' + emid + '"  ' + specialAttr + '   onclick="showOperateLayer(' + highlightid + ')">')
        };
        if (artcontent.indexOf('<span data-prehighlight="1">') != -1) {
            artcontent = artcontent.replace(/<span data-prehighlight="1">/g, '<span class="highlight" id="' + emid + '"  ' + specialAttr + '   onclick="showOperateLayer(' + highlightid + ')">')
        };
        document.getElementById("artcontent").innerHTML = artcontent;
        //新增批注红点
        var redDotID = "highlight_reddot_" + highlightid;
        var redDot = '<span id="' + redDotID + '" class="highlightreddot" style="display:none;width: 0.9rem;height:0.9rem;position: absolute;border-radius: 50%;background: #ff3b30;font-size: 0.5rem;line-height: 0.9rem;text-align: center;color: #fff;font-style: normal;margin-left:-0.2rem;letter-spacing: 0;bottom:0;text-indent:0;"></span>';
        var highlightNew2 = $('span[id=highlight_' + highlightid + ']:last');
        if (highlightNew2 != null) {
            highlightNew2.append(redDot);
        }
        //调整红点尺寸
        resizeReddotSize();
    }
    catch (e) {
        //还原正文内容
        document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
    }
}

//添加标记失败后刷新UI
function failAddHighLightRefreshUI() {
    try {
        //还原正文内容
        document.getElementById("artcontent").innerHTML = originalArticleContentHTML;
    }
    catch (e) {
    }
}

//成功删除批注后刷新UI
function successDeleteStickyRefreshUI(HighlightID, stickycount) {
    try {
        var highlightReddot = $('#highlight_reddot_' + HighlightID);
        if (stickycount == 0) {
            //批注都删没有，当前批注要变为标记的UI
            var highlightNew = $('#highlight_' + HighlightID);
            var highlightNew2 = $('span[id=highlight_' + HighlightID + ']:last');
            while (highlightNew.hasClass('sticky')) {
                highlightNew.removeClass('sticky').addClass('highlight')
            }
            if (highlightReddot != null) {
                //有此对象，更新红点数,并显示
                highlightReddot.html("");
                highlightReddot.hide();
            }
        }
        else {
            //批注还有，更新右上角批注数字
            if (highlightReddot != null) {
                //有此对象，更新红点数,并显示
                highlightReddot.html(stickycount);
                highlightReddot.show();
            }
        }
    }
    catch (e) {
    }
}

//成功添加批注后刷新UI
function successAddStickyRefreshUI(HighlightID, stickyid, stickycount) {
    try {
        var highlightReddot = $('#highlight_reddot_' + HighlightID);
        if (stickycount > 0) {
            if (stickycount > 99) {
                stickycount = 99;
            }
            var highlightNew1 = $('#highlight_' + HighlightID);
            var highlightNew2 = $('span[id=highlight_' + HighlightID + ']:last');
            while (highlightNew1.hasClass('highlight')) {
                highlightNew1.removeClass('highlight').addClass('sticky')
            }
            if (highlightReddot != null) {
                //有此对象，更新红点数,并显示
                highlightReddot.html(stickycount);
                highlightReddot.show();
            }
        }
        else {
            //批注变标记
            var highlightNew = $('#highlight_' + HighlightID);
            var highlightNew2 = $('span[id=highlight_' + HighlightID + ']:last');
            while (highlightNew.hasClass('sticky')) {
                highlightNew.removeClass('sticky').addClass('highlight')
            }
            //批注还有，更新右上角批注数字
            if (highlightReddot != null) {
                //有此对象，更新红点数，并隐藏
                highlightReddot.html("");
                highlightReddot.hide();
            }
        }
    }
    catch (e) {
    }
}

//成功删除标记后刷新UI
function successDeleteHighlightRefreshUI(HighlightID) {
    try {
        var emid = "highlight_" + HighlightID;
        for (var i = 0; i < $('span[id=highlight_' + HighlightID + ']').length; i++) {
            $('span[id=highlight_' + HighlightID + ']').eq(i).removeAttr('class');
            $('span[id=highlight_' + HighlightID + ']').eq(i).removeAttr('onclick')
        };


        var highlightReddot = $('#highlight_reddot_' + HighlightID);
        if (highlightReddot != null) {
            //有此对象，移除对象
            highlightReddot.remove();
        }
        var con = document.getElementById("artcontent");
        var markarticle = con.innerHTML;
        do {
            var startmark = "<SPAN id=" + emid + ">";
            var endmark = "</SPAN>";
            var start = markarticle.indexOf(startmark);
            var end = markarticle.indexOf(endmark, start);
            if (start == -1) {
                startmark = '<span id="' + emid + '">';
                endmark = "</span>";
                start = markarticle.indexOf(startmark);
                end = markarticle.indexOf(endmark, start)
            };
            if (start == -1) {
                startmark = "<span id=" + emid + ">";
                endmark = "</span>";
                start = markarticle.indexOf(startmark);
                end = markarticle.indexOf(endmark, start)
            };
            if (start != -1) {
                var target = markarticle.substring(start + startmark.length, end);
                var beforesubstr = markarticle.substring(0, start);
                var aftersubstr = markarticle.substring(end + endmark.length);
                markarticle = beforesubstr + target + aftersubstr
            }
        } while (start != -1);
        con.innerHTML = markarticle;
    }
    catch (e) {
    }
}

//判断是否是安卓
function isAndroid() {
    var useragent = navigator.userAgent.toLowerCase();
    if (useragent.toLowerCase().indexOf("android") > -1) {
        return true
    } else {
        return false
    }
}

//重新调整批注红点大小
function resizeReddotSize() {
    try {
        if (isAndroid()) {
            var FontSize = AliansBridge.getValueByKey("FontSize");
            changeReddotSize(FontSize)
        }
        else {
            jsBridge.callHandler('changeReddotSize', {}, function (response) { });
        }
    }
    catch (e) { }
}

//根据字号改变批注红点大小
function changeReddotSize(FontSize) {
    try {
        var stickyReddotSize;
        if (FontSize == 5) {
            stickyReddotSize = 4;
        } else if (FontSize == 4) {
            stickyReddotSize = 3;
        } else if (FontSize == 3) {
            stickyReddotSize = 2;
        } else if (FontSize == 2) {
            stickyReddotSize = 1;
        } else if (FontSize == 1) {
            stickyReddotSize = 0;
        } else {
            //默认
            stickyReddotSize = 1;
        }
        var reddotsize = [{
            "width": "0.6rem",
            "height": "0.6rem",
            "line-height": "0.6rem",
            "font-size": "0.4rem"
        }, {
            "width": "0.8rem",
            "height": "0.8rem",
            "line-height": "0.8rem",
            "font-size": "0.5rem"
        }, {
            "width": "0.9rem",
            "height": "0.9rem",
            "line-height": "0.9rem",
            "font-size": "0.5rem"
        }, {
            "width": "1.0rem",
            "height": "1.0rem",
            "line-height": "1.0rem",
            "font-size": "0.6rem"
        }, {
            "width": "1.2rem",
            "height": "1.2rem",
            "line-height": "1.2rem",
            "font-size": "0.8rem"
        }]
        $(".highlightreddot").css(reddotsize[stickyReddotSize]);
        $('.highlightreddot').each(function () {
            try {
                var obj = $(this);//红点
                var objparent = $(this).parent();//标记
                $(this).css('margin-bottom', $(objparent).css('font-size'));
            }
            catch (e) {
            }
        })

    }
    catch (e) { }
}